/*
Level Mask


(C) J Whitham 1994

'Amulet'
*/

#include <fastgraf.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define MaxX		( 40 )
#define MaxY		( 28 )
#define Size		( 16 )

typedef struct {
						unsigned char		Type ;
						unsigned char		X , Y ;
						} MONSTER ;

MONSTER				Monster [ 256 ] ;
char					Temp [ 200 ] ;
unsigned char		Text = 0 ;
unsigned char		Screen [ MaxX ][ MaxY ] ;
unsigned char		Screen2 [ MaxX ][ MaxY ] ;
unsigned char		Attribute [ MaxX ][ MaxY ] ;
char					TextString [ 100 ][ 76 ] ;
char					* Static [ 257 ] ;
int					X , Y , I ;
int					Stop = 0 , Number = 0 , Type , OK = 0 ;
int					Level ;
char					InputName [ 41 ] ;
char					OutputName [ 41 ] ;
unsigned char		Original [ 16 ][ 16 ] ;
unsigned char		MagicDoors , Coins , Boxes ;
unsigned char		Tablets , SpellBooks , Scrolls ;
unsigned char		Potions ;
FILE					* File ;


void DrawScreen ( void ) ;
void GetNumber ( char * String , unsigned char * Number ) ;
void GetText ( char * String , char * Text ) ;
void StraightConvert ( char * Anim ) ;



void main ( void )
{
	printf ( "\n\nLEVELMASK   (C) J Whitham 1994 'Amulet'\n\n" ) ;
	printf ( "Please enter the number of your level: " ) ;
	gets ( Temp ) ;
	Level = atoi ( Temp ) ;
	if ( Level < 1 || Level > 255 )
	{
		printf ( "\nBad level!" ) ;
		exit ( 0 ) ;
	}
	printf ( "\n\n\nLoading, please wait..." ) ;
	sprintf ( InputName , "GAMELEVL.%d" , Level ) ;
	sprintf ( OutputName , "GAMELEVM.%d" , Level ) ;
	File = fopen ( InputName , "rb" ) ;
	if ( File == NULL )
	{
		printf ( "\nThis level does not exist" ) ;
		exit ( 0 ) ;
	}
	if ( fread ( Screen , sizeof ( Screen ) , 1 , File ) != 1 )
	{
		fclose ( File ) ;
		printf ( "\nLevel file contains invalid data" ) ;
		exit ( 0 ) ;
	}
	memmove ( Screen2 , Screen , 1120 ) ;
	fclose ( File ) ;
	for ( I = 1 ; I < 256 ; I ++ )
	{
		sprintf ( Temp , "GAMECHR.%d" , I ) ;
		Static [ I ] = malloc ( 128 ) ;
		if ( Static [ I ] == NULL )
		{
			printf ( "\nOut of memory error" ) ;
			exit ( 0 ) ;
		}
		File = fopen ( Temp , "rb" ) ;
		if ( File != NULL )
		{
			if ( fread ( Original , 256 , 1 , File ) != 1 )
			{
				printf ( "\nInvalid data error, file %s" , Temp ) ;
				fclose ( File ) ;
				exit ( 0 ) ;
			}
			fclose ( File ) ;
			StraightConvert ( Static [ I ] ) ;
		} else {
			if ( I > 2 )
			{
				memmove ( Static [ I ] , Static [ 2 ] , 128 ) ;
			} else {
				printf ( "\nALERT ERROR 2" ) ;
				exit ( 0 ) ;
			}
		}
	}
	fclose ( File ) ;
	printf ( "\nPlease wait, processing..." ) ;
	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			switch ( Screen [ X ][ Y ] )
			{
				case 149 :	MagicDoors ++ ;
								break ;
				case 150 :	Coins ++ ;
								break ;
				case 152 :	Boxes ++ ;
								break ;
				case 162 :	Tablets ++ ;
								break ;
				case 163 :	SpellBooks ++ ;
								break ;
				case 164 :	Scrolls ++ ;
								break ;
				case 165 :	Potions ++ ;
								break ;
				default :	break ;
			}
		}
	}
	printf ( "\n\nLEVEL DETAILS\n\n" ) ;
	printf ( "You have:\n" ) ;
	printf ( "%4d Magic Doors\n" , MagicDoors ) ;
	printf ( "%4d Coins\n" , Coins ) ;
	printf ( "%4d Boxes\n" , Boxes ) ;
	printf ( "%4d Tablets\n" , Tablets ) ;
	printf ( "%4d Spellbooks\n" , SpellBooks ) ;
	printf ( "%4d Scrolls\n" , Scrolls ) ;
	printf ( "%4d Potions\n\n" , Potions ) ;
	printf ( "Quick help: now you will go through all of the above and set attributes\n" ) ;
	printf ( "about it, eg. the amount of Coins there are in a pile.\n\n" ) ;
	printf ( "Press any key to start:" ) ;
	(void) getch () ;
	fg_setmode ( 18 ) ;
	DrawScreen () ;
	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			switch ( Screen [ X ][ Y ] )
			{
				case 149 :	GetNumber ( "EXPERIENCE REQUIRED FOR MAGIC DOOR" ,
										& Attribute [ X ][ Y ] ) ;
								break ;
				case 150 :	GetNumber ( "VALUE IN GOLD OF THIS PILE" ,
										& Attribute [ X ][ Y ] ) ;
								break ;
				case 152 :	GetNumber ( "CODE NUMBER FOR CONTENTS OF BOX" ,
										& Attribute [ X ][ Y ] ) ;
								break ;
				case 162 :  Text ++ ;
								GetText ( "ON TABLET" ,
										TextString [ Text ] ) ;
								Attribute [ X ][ Y ] = (unsigned char) Text ;
								break ;
				case 163 :	GetNumber ( "CODE NUMBER FOR SPELL IN BOOK" ,
										& Attribute [ X ][ Y ] ) ;
								break ;
				case 164 :	GetNumber ( "CODE NUMBER FOR SPELL ON SCROLL" ,
										& Attribute [ X ][ Y ] ) ;
								break ;
				case 165 :	GetNumber ( "CODE NUMBER FOR POTION" ,
										& Attribute [ X ][ Y ] ) ;
								break ;
				default :	Attribute [ X ][ Y ] = 255 ;
								break ;
			}
			fg_setcolor ( 0 ) ;
			Screen [ X ][ Y ] = 1 ;
			fg_rect ( Size * X , ( Size * X ) + Size - 1 ,
						Size * Y , ( Size * Y ) + Size - 1 ) ;
		}
	}
	fg_setmode ( 3 ) ;
	printf ( "LEVELMASKING complete!\n\n" ) ;
	printf ( "Are there any monsters on this level (Y\\N)?" ) ;
	if ( toupper ( getch () ) == 'Y' )
	{
		printf ( "yes\n\n" ) ;
		printf ( "You may have a maximum of 255 monsters in the level.\n\n" ) ;
		memmove ( Screen , Screen2 , 1120 ) ;
		Number = 1 ;
		while ( ! Stop )
		{
			printf ( "\n\nMonster #%d\n\n" , Number ) ;
			printf ( "Enter code number for monster type: " ) ;
			gets ( Temp ) ;
			Type = atoi ( Temp ) ;
			while ( Type < 1 || Type > 255 )
			{
				printf ( "\nNumber must be from 1-255: " ) ;
				gets ( Temp ) ;
				Type = atoi ( Temp ) ;
			}
			fg_setmode ( 18 ) ;
			DrawScreen () ;
			fg_move ( 0 , 479 ) ;
			fg_setcolor ( 14 ) ;
			fg_print ( "MOVE TO WHERE MONSTER WILL START. WHITE/BLACK BOXES INDICATE MARKED AREAS" , 73 ) ;
			OK = 0 ;
			X = 0 ;
			Y = 0 ;
			while ( ! OK )
			{
				if ( Screen [ X ][ Y ] == 1 )
				{
					while ( ! kbhit () )
					{
						for ( I = 0 ; I < 17 ; I ++ )
						{
							fg_setcolor ( I ) ;
							fg_box ( ( X * Size ) , ( X * Size ) + Size - 1 ,
								( Y * Size ) , ( Y * Size ) + Size - 1 ) ;
						}
					}
					switch ( getch () )
					{
						case 13 :	Screen [ X ][ Y ] = 2 ;
										Monster [ Number ] . Type = (unsigned char) Type ;
										Monster [ Number ] . X = (unsigned char) X ;
										Monster [ Number ] . Y = (unsigned char) Y ;
										Number ++ ;
										OK = 1 ;
										break ;
						case 32 :	X ++ ;
										if ( X >= MaxX )
										{
											X = 0 ;
											Y ++ ;
											if ( Y >= MaxY )
											{
												Y = 0 ;
											}
										}
										break ;
						case 27 :	OK = 1 ;
										break ;
					}
				} else {
					X ++ ;
					if ( X >= MaxX )
					{
						X = 0 ;
						Y ++ ;
						if ( Y >= MaxY )
						{
							Y = 0 ;
						}
					}
				}
			}
			fg_setmode ( 3 ) ;
			if ( Number > 255 )
			{
				printf ( "\n\nThat's your limit." ) ;
				Stop = 1 ;
			} else {
				printf ( "\n\nAny more (Y\\N)?" ) ;
				if ( toupper ( getch () ) == 'Y' )
				{
					printf ( "yes" ) ;
				} else {
					Stop = 1 ;
				}
			}
		}
	}
	printf ( "no\n\nSaving data out..." ) ;
	File = fopen ( OutputName , "wb" ) ;
	fwrite ( Attribute , sizeof ( Attribute ) , 1 , File ) ;
	fwrite ( & Text , 1 , 1 , File ) ;
	for ( I = 1 ; I <= Text ; I ++ )
	{
		fwrite ( TextString [ I ] ,
			sizeof ( TextString [ I ] ) , 1 , File ) ;
	}
	Text = Number ;
	fwrite ( & Text , 1 , 1 , File ) ;
	if ( Number > 0 )
	{
		fwrite ( Monster , 3 , Number , File ) ;
	}
	fclose ( File ) ;
	for ( I = 1 ; I < 256 ; I ++ )
	{
		free ( Static [ I ] ) ;
	}
	printf ( "done\n\n" ) ;
}

void DrawScreen ( void )
{
	int		X , Y ;

	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			fg_move ( X * Size , ( Y * Size ) + Size - 1 ) ;
			fg_putimage ( Static [ Screen [ X ][ Y ] ] , 8 , 16 ) ;
		}
	}
}

void GetNumber ( char * String , unsigned char * Number )
{
	int		I ;

	while ( ! kbhit () )
	{
		for ( I = 0 ; I < 16 ; I ++ )
		{
			fg_setcolor ( I ) ;
			fg_box ( ( X * Size ) , ( X * Size ) + Size - 1 ,
						( Y * Size ) , ( Y * Size ) + Size - 1 ) ;
		}
	}
	(void) getch () ;
	fg_setmode ( 3 ) ;

	printf ( "ENTER %s\n\n\n" , String ) ;
	I = 0 ;
	while ( I < 1 || I > 255 )
	{
		printf ( "\n>> " ) ;
		gets ( Temp ) ;
		I = atoi ( Temp ) ;
	}
	(* Number) = I ;

	fg_setmode ( 18 ) ;
	DrawScreen () ;
}

void GetText ( char * String , char * Text )
{
	int		I ;

	while ( ! kbhit () )
	{
		for ( I = 0 ; I < 16 ; I ++ )
		{
			fg_setcolor ( I ) ;
			fg_box ( ( X * Size ) , ( X * Size ) + Size - 1 ,
						( Y * Size ) , ( Y * Size ) + Size - 1 ) ;
		}
	}
	(void) getch () ;
	fg_setmode ( 3 ) ;

	printf ( "ENTER TEXT %s\n\n\n\n" , String ) ;

	printf ( ">> " ) ;
	gets ( Temp ) ;
	Temp [ 75 ] = '\0' ;

	memmove ( Text , Temp , 76 ) ;
	fg_setmode ( 18 ) ;
	DrawScreen () ;
}

void StraightConvert ( char * Anim )
{
	int	X , Y , K , J ;


	J = 0 ;
	for ( Y = 15 ; Y > -1 ; Y -- )
	{
		for ( X = 0 ; X < 16 ; X += 2 )
		{
			K = ( Original [ X ][ Y ] * 16 ) +
					Original [ X + 1 ][ Y ] ;
			Anim [ J ] = K ;
			J ++ ;
		}
	}
}

